#INCLUDE "dcdialog.CH"
#INCLUDE "adsdbe.CH"
#INCLUDE "dcads.CH"

#define MSG_DBE_NOT_LOADED   " database engine not loaded"
#define MSG_DBE_NOT_CREATED  " database engine could not be created"

PROC Appsys ; RETURN

FUNCTION Main()

LOCAL GetList[0], oBrowseUsers, aUserObjects[0], oBrowseTables, aTableObjects[0], ;
      oBrowseLocks, aLockObjects[0], bLoadUsers

bLoadUsers := {||LoadConnectedUsers( @oBrowseUsers, aUserObjects )}

Eval(bLoadUsers)

@ 0,0 DCSAY 'Users:' SAYSIZE 0 FONT '10.Lucida Console Bold'

@ 0,20 DCPUSHBUTTON CAPTION 'Refresh' SIZE 10,1 ;
      ACTION bLoadUsers

@ 0,30 DCPUSHBUTTON CAPTION 'Kill User' SIZE 10,1 ;
      ACTION {||KillUser( aUserObjects[oBrowseUsers:arrayElement]:UserName), ;
                Eval(bLoadUsers)}

@ 1,0 DCBROWSE oBrowseUsers DATA aUserObjects SIZE 130,20 ;
      FONT '10.Lucida Console' ;
      ITEMMARKED {|a,b,o|LoadUserTables(aUserObjects[o:arrayElement]:UserName, ;
                                        @oBrowseTables,aTableObjects)}

DCBROWSECOL OBJECTVAR 'UserName' HEADER 'UserName' WIDTH 20 PARENT oBrowseUsers ;

DCBROWSECOL OBJECTVAR 'Address' HEADER 'Address' WIDTH 20 PARENT oBrowseUsers ;

DCBROWSECOL OBJECTVAR 'OSUserLoginName' HEADER 'OS User Login Name' WIDTH 15 PARENT oBrowseUsers ;

DCBROWSECOL OBJECTVAR 'TSAddress' HEADER 'TSAddress' WIDTH 15 PARENT oBrowseUsers ;

DCBROWSECOL OBJECTVAR 'ApplicationID' HEADER 'ApplicationID' WIDTH 40 PARENT oBrowseUsers ;

@ 22,0 DCSAY 'User Tables:' SAYSIZE 0 FONT '10.Lucida Console Bold'

@ 23,0 DCBROWSE oBrowseTables DATA aTableObjects SIZE 70,20 ;
      FONT '10.Lucida Console' ;
      ITEMMARKED {|a,b,o|LoadUserLocks(aTableObjects[o:arrayElement]:TableName, ;
                                       aUserObjects[oBrowseUsers:arrayElement]:UserName, ;
                                       @oBrowseLocks,aLockObjects)}

DCBROWSECOL OBJECTVAR 'TableName' HEADER 'Table Name' WIDTH 60 PARENT oBrowseTables ;

@ 22,72 DCSAY 'User Locks:' SAYSIZE 0 FONT '10.Lucida Console Bold'

@ 23,72 DCBROWSE oBrowseLocks DATA aLockObjects SIZE 30,20 ;
      FONT '10.Lucida Console'

DCBROWSECOL OBJECTVAR 'LockedRecNo' HEADER 'Locked Record No.' WIDTH 25 PARENT oBrowseLocks ;

DCREAD GUI FIT TITLE 'ADS Management Utility. Server: ' + Ads_SessionDict():getConnectionString() ;

RETURN nil

* -----------

STATIC FUNCTION LoadConnectedUsers( oBrowse, aObjects )

LOCAL cSql, cAlias := 'USERS'

ASize(aObjects,0)

TEXT INTO cSql WRAP
SELECT * FROM
(
  EXECUTE PROCEDURE sp_mgGetConnectedUsers()
) anyalias
ENDTEXT

SQL cSql INTO OBJECTS aObjects INTO CURSOR cAlias VIA (Ads_SessionDict())

IF Valtype(oBrowse) == 'O'
  oBrowse:refreshAll()
ENDIF

dbCloseArea()

RETURN nil

* -----------

STATIC FUNCTION LoadUserTables( cUserName, oBrowse, aObjects )

LOCAL cSql, cAlias := 'TABLES'

PRIVATE pUserName := Trim(cUserName)

ASize(aObjects,0)

TEXT INTO cSql WRAP
SELECT * FROM
(
  EXECUTE PROCEDURE sp_mgGetUserTables( '&pUserName' )
) anyalias
ENDTEXT

SQL cSql INTO OBJECTS aObjects INTO CURSOR cAlias VIA (Ads_SessionDict())

IF Valtype(oBrowse) == 'O'
  oBrowse:refreshAll()
ENDIF

dbCloseArea()

RETURN nil

* -----------

STATIC FUNCTION LoadUserLocks( cTableName, cUserName, oBrowse, aObjects )

LOCAL cSql, cAlias := 'LOCKS'

PRIVATE pUserName := Trim(cUserName), ;
        pTableName := Trim(cTableName)

ASize(aObjects,0)

TEXT INTO cSql WRAP
SELECT * FROM
(
  EXECUTE PROCEDURE sp_mgGetUserLocks( '&pTableName', '&pUserName' )
) anyalias
ENDTEXT

SQL cSql INTO OBJECTS aObjects INTO CURSOR cAlias VIA (Ads_SessionDict())

IF Valtype(oBrowse) == 'O'
  oBrowse:refreshAll()
ENDIF

dbCloseArea()

RETURN nil

* -----------

STATIC FUNCTION KillUser( cUserName )

LOCAL cSql, cAlias := 'USERS', lStatus

PRIVATE pUserName := Trim(cUserName)

DCMSGBOX 'Kill User: ' + Trim(cUserName) + ' ?' YESNO TO lStatus ;
   FONT '10.Lucida Console'

IF !lStatus
  RETURN .f.
ENDIF

TEXT INTO cSql WRAP
EXECUTE PROCEDURE sp_mgKillUser('&pUserName')
ENDTEXT

SQL cSql INTO CURSOR cAlias VIA (Ads_SessionDict())

dbCloseArea()

RETURN nil

* -----------

PROCEDURE dbeSys()
  LOCAL i

  LOCAL aDbes := { { "FOXDBE", .T.},;
                   { "CDXDBE", .T.}}
  LOCAL aBuild :={ { "FOXCDX", 1, 2 } }

  LOCAL cAdsServerFree, cadsServerDict, lAdsCompatible, aData, oAdsSessionFree, oAdsSessionDict, cSessionFree, cSessionDict, cError

  SET COLLATION TO AMERICAN
  SET DATE TO AMERICAN

  FOR i:= 1 TO len(aDbes)
      IF ! DbeLoad( aDbes[i][1], aDbes[i][2])
         Alert( aDbes[i][1] + MSG_DBE_NOT_LOADED , {"OK"} )
      ENDIF
  NEXT i

  FOR i:= 1 TO len(aBuild)
      IF ! DbeBuild( aBuild[i][1], aDbes[aBuild[i][2]][1], aDbes[aBuild[i][3]][1])
         Alert( aBuild[i][1] + MSG_DBE_NOT_CREATED , {"OK"} )
      ENDIF
  NEXT i

  cAdsServerFree := Space(100)
  cAdsServerDict := Space(100)
  lAdsCompatible := .T.
  aData := { cAdsServerFree, cAdsServerDict, lAdsCompatible }
  DC_IniLoad('AdsMgt.Ini','DATABASES',aData, {'AdsServerFree','AdsServerDict','AdsCompatible'})
  cAdsServerFree := AllTrim(aData[1])
  cAdsServerDict := AllTrim(aData[2])
  lAdsCompatible := .F.

  IF !Empty(cAdsServerFree) .OR. !Empty(cAdsServerDict)

    IF !"ADSDBE" $ DbeList()
      IF !DbeLoad( "ADSDBE" )
        DC_WinAlert( "Unable to load ADSDBE", "ADS Server",, ;
                      XBPMB_WARNING + XBPMB_APPMODAL )
        QUIT
      ENDIF
    ENDIF

    DbSetNullValue(.f.)
    SET NULLVALUE OFF

    cSessionFree := "DBE=ADSDBE;SERVER=" + cAdsServerFree+";DbfsUseNull=FALSE"
    oAdsSessionFree := DC_DacSession():new(cSessionFree)

    cSessionDict := "DBE=ADSDBE;SERVER=" + cAdsServerDict+";DbfsUseNull=FALSE"
    oAdsSessionDict := DC_DacSession():new(cSessionDict)

    IF !oAdsSessionFree:isConnected() .OR. !oAdsSessionDict:isConnected()
      cError := ""
      IF !oAdsSessionFree:isConnected()
        cError += "Free Table Error Code: " + Alltrim(Str(oAdsSessionFree:getLastError())) + Chr(13) + oAdsSessionFree:getLastMessage()
      ENDIF
      IF !oAdsSessionDict:isConnected()
        IF !Empty(cError)
          cError += Chr(13)
        ENDIF
        cError += "Dictionary Error Code: " + Alltrim(Str(oAdsSessionDict:getLastError())) + Chr(13) + oAdsSessionDict:getLastMessage()
      ENDIF

      DC_WinAlert( "Unable to establish connection to ADS Server" + Chr(13) + cError )
      QUIT
    ENDIF

    oAdsSessionFree:setDefault(.t.)
    Ads_Session( oAdsSessionFree)
    Ads_SessionDict( oAdsSessionDict)

    dbeSetDefault('ADSDBE')
    DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADSDBE_CDX )
    DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADSDBE_CDX )
    IF lAdsCompatible
      DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ADSDBE_COMPATIBLE_LOCKING  )
    ELSE
      DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ADSDBE_PROPRIETARY_LOCKING  )
    ENDIF
    dbeSetDefault('ADSDBE')
  ENDIF

RETURN

* -------------

EXIT PROCEDURE AdsDisconnect

LOCAL oSession

oSession := Ads_Session()
IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
  oSession:disconnect()
ENDIF

oSession := Ads_SessionDict()
IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
  oSession:disconnect()
ENDIF

RETURN

* -------------

FUNCTION Ads_Session( oSession )

STATIC soSession

IF Valtype(oSession) = 'O'
  soSession := oSession
ENDIF

RETURN soSession

* ------------

FUNCTION Ads_SessionDict( oSession )

STATIC soSessionDict

IF Valtype(oSession) = 'O'
  soSessionDict := oSession
ENDIF

RETURN soSessionDict


